<?php
	$rcsid = "\$Fuller: myprograms/htbm/web/bmadmin.php,v 1.30 2004/02/08 03:37:07 fullermd Exp $";

	/* Include our stuff */
	$rootdir = ".";
	include("${rootdir}/php/main.php");

	/* Start up */
	$db = db_connect();

	/* Auth */
	if($admin_auth_req==1)
	{ admin_auth(); }

	/* Pull some variables we need */
	$commit = $_REQUEST['commit'];
	$amode = $_REQUEST['amode'];

	/* The global config stuff */
	$confenc = $_REQUEST['conf'];
	$conf = unserialize(base64_decode($confenc));


	/* Our various modes */
	if($amode=="edit")
	{
		/* Create/edit a bookmark */
		$mark_id = $_REQUEST['mark_id'];
		if(!isset($mark_id))
			$mark_id=0;
		$mid_q = db_quote($mark_id);

		/* Just do the header here */
		print_head("Bookmark Administration", $rcsid);

		if(isset($commit))
		{
			/* Commit general info changes */
			$url = $_REQUEST['url'];
			$title = $_REQUEST['title'];
			$comment = $_REQUEST['comment'];

			/* Build up a backward link */
			$url_e = urlencode($url);
			$title_e = urlencode($title);
			$comment_e = urlencode($comment);

			$backlink = "$self?amode=edit&amp;mark_id=$mark_id&amp;"
					. "url=$url_e&amp;title=$title_e&amp;"
					. "comment=$comment_e&amp;conf=$confenc";

			/* Do some sanity checking */
			$warnstr = "";
			if(!$url)
			{
				print <<< _EOF_
<h1>ERROR: Need URL specified!</h1>
<p>
 <a href="$backlink">Re-edit</a>
</p>

_EOF_;
				print_foot();
				exit(1);
			}
			$urlp = parse_url($url);
			if(strlen($urlp['scheme']) < 1)
			{
				$warnstr .= "<li>No URL scheme specified, assuming "
						. "http://.  You should edit this bookmark "
						. "if this isn't what you want.</li>";
				$url = "http://" . $url;
			}
			if(!$title)
			{
				$warnstr .= "<li>No title entered, using URL.  You may want "
						. "to edit this bookmark and add a real title."
						. "</li>";
				$title = $url;
			}

			/* Escape info for safety */
			$url_q = db_quote($url);
			$title_q = db_quote($title);
			$comment_q = db_quote($comment);

			/* Stuff the data */
			$newmark=0;
			if($mark_id==0)
			{
				/* New bookmark */
				$newmark=1;
				db_query("BEGIN");

				$mid_q = "nextval('bookmarks_mark_id_seq')";
				$querystr = "INSERT INTO bookmarks "
						. "(mark_id,url,title,comment,created) "
						. "VALUES ($mid_q,$url_q,$title_q,$comment_q,"
						. "CURRENT_TIMESTAMP)";
				db_query($querystr);

				/* Get our mark_id */
				$mid_q = "currval('bookmarks_mark_id_seq')";
				$query = "SELECT $mid_q AS mid";
				$result = db_query($query);
				$row = db_getrow($result);
				$mark_id = db_dequote($row['mid']);
				$mid_q = db_quote($mark_id);
				db_qfree($result);

				/*
				 * New bookmarks need to be stuck in their category right
				 * off.
				 */
				$parent_q = db_quote($_REQUEST['parent']);
				$query = "INSERT INTO bm_links (mark_id,parent) "
						. "VALUES ($mid_q,$parent_q)";
				db_query($query);

				/* 'nuff */
				db_query("COMMIT");
			}
			else
			{
				/* Edit */
				$querystr = "UPDATE bookmarks SET "
						. "url=$url_q, title=$title_q, "
						. "comment=$comment_q "
						. "WHERE mark_id=$mid_q";
				db_query($querystr);
			}


			/* If we get here, success! */
			if($newmark==1)
				print("<h1>New bookmark added!</h1>\n");
			else
				print("<h1>Bookmark info updated!</h1>\n");

			if(strlen($warnstr)>0)
				print("<h2>Warnings:</h2><ul>$warnstr</ul>\n");
		}
		else if(isset($_REQUEST['ed_chcat']))
		{
			/* Change a parent category */
			$parent = $_REQUEST['parent'];
			$old_parent = $_REQUEST['old_parent'];

			/* See if we actually need to do crap */
			if($parent!=$old_parent)
			{
				$parent_q = db_quote($parent);
				$old_q = db_quote($old_parent);
				$query = "UPDATE bm_links SET "
						. "parent=$parent_q "
						. "WHERE parent=$old_q "
						. "AND mark_id=$mid_q";
				db_query($query);
				/* XXX Error-checking */
				print("<h1>Parent category updated!</h1>\n");
			}
		}
		else if(isset($_REQUEST['ed_addcat']))
		{
			/* Add a parent category */
			$parent = $_REQUEST['parent'];
			$parent_q = db_quote($parent);
			$query = "INSERT INTO bm_links "
					. "(mark_id,parent) "
					. "VALUES ($mid_q,$parent_q)";
			db_query($query);
			/* XXX Error-checking */
			print("<h1>New parent category added!</h1>\n");
		}
		else if(isset($_REQUEST['ed_delcat']))
		{
			/* Delete a parent category */
			$parent = $_REQUEST['parent'];
			$parent_q = db_quote($parent);
			$query = "DELETE FROM bm_links "
					. "WHERE parent=$parent_q "
					. "AND mark_id=$mid_q";
			db_query($query);
			/* XXX Error-checking */
			print("<h1>Parent category deleted!</h1>\n");
		}

		/* Now, print the edit form */
		if($mark_id!=0)
		{
			/* We're editing */
			$mid_q = db_quote($mark_id);

			$querystr = "SELECT bookmarks.mark_id,url,title,comment,"
					. "bm_links.parent "
					. "FROM bookmarks "
					. "FULL OUTER JOIN bm_links USING (mark_id) "
					. "WHERE mark_id=$mid_q";
			$result = db_query($querystr);
			$nrows = db_numrows($result);
			if($nrows == 0)
			{
				print("<p>Bookmark ID not found!</p>\n");
				print("<p><a href=\"bookmarks.php?conf=$confenc\">"
						. "Back to Bookmarks</a></p>\n");
				exit;
			}

			/* Build up the info */
			$bminfo = array();
			$bminfo['parents'] = array();
			while($info = db_getrow($result))
			{
				$bminfo['mark_id'] = db_dequote($info['mark_id']);
				$bminfo['url'] = db_dequote($info['url']);
				$bminfo['title'] = db_dequote($info['title']);
				$bminfo['comment'] = db_dequote($info['comment']);
				array_unshift($bminfo['parents'],
						db_dequote($info['parent']));
			}
			db_qfree($result);
		}
		else
		{
			/* We're creating, so initialize something empty */
			$bminfo = array();
			$bminfo['mark_id'] = 0;
			$bminfo['url'] = "";
			$bminfo['title'] = "";
			$bminfo['comment'] = "";
			$bminfo['parents'] = array('0' => '-1');
		}

		/* Print out the form */
		if($mark_id==0)
			print("<h1>Add new bookmark</h1>\n");
		else
			print("<h1>Edit bookmark</h1>\n");

		/* Slap up the form */
		print_bmark_form($bminfo);
		print <<< _EOF_
<form method="get" action="bookmarks.php">
 <p>
  <input type="hidden" name="conf" value="$confenc" />
  <input type="submit" name="dummy" value="Back to Bookmarks" />
 </p>
</form>

_EOF_;

		/* That's it for creating/editing */
		print_foot();
		exit(0);
	}
	else if($amode=="dele")
	{
		/* Delete existing bookmark */
		$mark_id = $_REQUEST['mark_id'];
		$mid_q = db_quote($mark_id);

		/* Just do the header here */
		print_head("Bookmark Administration", $rcsid);

		if(isset($commit))
		{
			/* Do the actual deletion */
			$querystr = "BEGIN";
			db_query($querystr);

			/* Delete the links */
			$mid_q = db_quote($mark_id);
			$querystr = "DELETE FROM bm_links WHERE mark_id=$mid_q";
			db_query($querystr);

			/* Delete the entry */
			$querystr = "DELETE FROM bookmarks WHERE mark_id=$mid_q";
			db_query($querystr);

			/* End this transaction */
			$querystr = "COMMIT";
			db_query($querystr);

			/* Success */
			if($conf['debug']==1)
			{
				/* If in debug mode, print a message */
				print("<p>Ex-bookmark number $mark_id deleted!</p>\n");
				print("<p>\n");
				print("<a href=\"bookmarks.php?conf=$confenc\">"
						. "Back to bookmarks</a>\n");
				print("</p>\n");
				print_foot();
				exit(0);
			}
			else
			{
				/* Else, just bounce */
				header("Location: bookmarks.php?conf=$confenc");
				exit(0);
			}
		}

		/* First, look up its info */
		$querystr = <<< _EOF_
SELECT
  bookmarks.mark_id AS mid,url,title,comment,categories.name AS cname
FROM
  bookmarks FULL OUTER JOIN bm_links bm1 USING (mark_id),
  bm_links bm2 LEFT JOIN categories ON categories.cat_id=bm2.parent
WHERE
  bookmarks.mark_id=$mid_q
 AND
  bm2.parent=bm1.parent
 AND
  bm2.mark_id=bm1.mark_id

_EOF_;
		$result = db_query($querystr);
		$nrows = db_numrows($result);
		if($nrows == 0)
		{
			print("<p>Bookmark ID not found!</p>\n");
			print("<p><a href=\"bookmarks.php?conf=$confenc\">"
					. "Back to Bookmarks</a></p>\n");
			print_foot();
			exit(1);
		}

		$bminfo = array();
		$bminfo['parents'] = array();
		while($info = db_getrow($result))
		{
			$bminfo['mark_id'] = db_dequote($info['mid']);
			$bminfo['url'] = db_dequote($info['url']);
			$bminfo['title'] = db_dequote($info['title']);
			$bminfo['comment'] = db_dequote($info['comment']);
			array_unshift($bminfo['parents'],
					db_dequote($info['cname']));
		}
		db_qfree($result);

		/* Now, print out the form */
		print <<< _EOF_
<h1>CONFIRM DELETE</h1>
<form action="$self" method="post">

_EOF_;
		print_bmark_form($bminfo);
		print <<< _EOF_
<div>
<input type="hidden" name="amode" value="dele" />
<input type="hidden" name="conf" value="$confenc" />
<input type="hidden" name="mark_id" value="$mark_id" />
</div>
<p>
Are you <em>SURE</em> you want to permamently delete this bookmark?
</p>
<p>
<input type="submit" name="commit" value="Delete" />
</p>
</form>
<form method="get" action="bookmarks.php">
 <p>
  <input type="hidden" name="conf" value="$confenc" />
  <input type="submit" name="dummy" value="Back to Bookmarks" />
 </p>
</form>

_EOF_;
		/* That's it for deletion */
		print_foot();
		exit(0);
	}
	else if($amode=="catedit")
	{
		/* Create/edit a category */
		$cat_id = $_REQUEST['cat_id'];
		if(!isset($cat_id))
			$cat_id=0;
		$cid_q = db_quote($cat_id);

		/* Just print the header here */
		print_head("Bookmark Administration", $rcsid);

		if(isset($commit))
		{
			/* Commit in info we're passed */
			$cat_id = $_REQUEST['cat_id'];
			$name = $_REQUEST['name'];

			/* Run away! */
			$name_q = db_quote($name);

			/* Write edited category information */
			$newcat=0;
			if($cat_id==0)
			{
				/* Brand spankin' new */
				$newcat=1;
				db_query("BEGIN");

				/* Add the category */
				$cid_q = "nextval('categories_cat_id_seq')";
				$querystr = "INSERT INTO categories "
						. "(cat_id,name) "
						. "VALUES ($cid_q,$name_q)";
				db_query($querystr);

				/* Get the category ID */
				$cid_q = "currval('categories_cat_id_seq')";
				$query = "SELECT $cid_q AS cid";
				$result = db_query($query);
				$row = db_getrow($result);
				$cat_id = db_dequote($row['cid']);
				$cid_q = db_quote($cat_id);
				db_qfree($result);

				/* Add its parent */
				$parent_q = db_quote($_REQUEST['parent']);
				$query = "INSERT INTO cat_links "
						. "(cat_id,parent) "
						. "VALUES ($cid_q,$parent_q)";
				db_query($query);

				/* 's'it */
				db_query("COMMIT");
			}
			else
			{
				/* Edit */
				$querystr = "UPDATE categories SET "
						. "name=$name_q "
						. "WHERE cat_id=$cid_q";
				db_query($querystr);
			}

			/* Success */
			if($newcat==1)
				print("<h1>New category added!</h1>\n");
			else
				print("<h1>Category info updated!</h1>\n");
		}
		else if(isset($_REQUEST['ed_chpar']))
		{
			/* Change parent category */
			$parent = $_REQUEST['parent'];
			$old_parent = $_REQUEST['old_parent'];

			/* See if we actually need to do crap */
			if($parent!=$old_parent)
			{
				$parent_q = db_quote($parent);
				$old_q = db_quote($old_parent);
				$query = "UPDATE cat_links SET "
						. "parent=$parent_q "
						. "WHERE parent=$old_q "
						. "AND cat_id=$cid_q";
				db_query($query);
				/* XXX Error-checking */
				print("<h1>Parent category updated!</h1>\n");
			}
		}
		else if(isset($_REQUEST['ed_addpar']))
		{
			/* Add a parent category */
			$parent = $_REQUEST['parent'];
			$parent_q = db_quote($parent);
			$query = "INSERT INTO cat_links "
					. "(cat_id,parent) "
					. "VALUES ($cid_q,$parent_q)";
			db_query($query);
			/* XXX Error-checking */
			print("<h1>New parent category added!</h1>\n");
		}
		else if(isset($_REQUEST['ed_delpar']))
		{
			/* Delete a parent category */
			$parent = $_REQUEST['parent'];
			$parent_q = db_quote($parent);
			$query = "DELETE FROM cat_links "
					. "WHERE parent=$parent_q "
					. "AND cat_id=$cid_q";
			db_query($query);
			/* XXX Error-checking */
			print("<h1>Parent category deleted!</h1>\n");
		}

		/* Now, see what info we need to display */
		if($cat_id!=0)
		{
			/* We're editing a pre-existing category */
			$cid_q = db_quote($cat_id);
			$querystr = "SELECT name,parent "
					. "FROM categories "
					. "FULL OUTER JOIN cat_links USING (cat_id) "
					. "WHERE categories.cat_id=$cid_q";
			$result = db_query($querystr);
			$nrows = db_numrows($result);
			if($nrows == 0)
			{
				print("<h1>Error</h1>\n<p>Category ID $cat_id not "
						. "found!</p>\n<p><a href=\"bookmarks.php?"
						. "conf=$confenc\">Back to Bookmarks</a></p>\n");
				print_foot();
				exit(1);
			}

			/*
		 	 * We have to parse this out into a nice format to send into
		 	 * print_cat_form();
		 	 */
			$catinfo = array();
			$catinfo['parents'] = array();
			$catinfo['cat_id'] = $cat_id;
			while($info = db_getrow($result))
			{
				$catinfo['name'] = db_dequote($info['name']);
				array_unshift($catinfo['parents'],
						db_dequote($info['parent']));
			}
			db_qfree($result);
		}
		else
		{
			/* Fill out a dummy structure */
			$catinfo = array();
			$catinfo['cat_id'] = 0;
			$catinfo['name'] = "";
			$catinfo['parents'] = array("0" => "-1");
		}

		if($cat_id==0)
			print("<h1>Add new category</h1>\n");
		else
			print("<h1>Edit category</h1>\n");

		print_cat_form($catinfo);
		print <<< _EOF_
<form method="get" action="bookmarks.php">
 <p>
  <input type="hidden" name="conf" value="$confenc" />
  <input type="submit" name="dummy" value="Back to Bookmarks" />
 </p>
</form>

_EOF_;
		/* That's all for here */
		print_foot();
		exit(0);
	}
	else if($amode=="catdele")
	{
		/* Delete existing bookmark */
		$cat_id = $_REQUEST['cat_id'];
		$cid_q = db_quote($cat_id);

		/* Just do the header here */
		print_head("Bookmark Administration", $rcsid);

		if(isset($commit))
		{
			/*
			 * Do the deletion.
			 * First, see if we CAN delete it.  If it has children, we'll
			 * just bail right now.  We need to add more flexibility
			 * here.
			 */
			$querystr = "SELECT COUNT(mark_id) AS nmarks FROM bm_links "
					. "WHERE parent=$cid_q";
			$result = db_query($querystr);
			$temp = db_getrow($result);
			$nbm = db_dequote($temp['nmarks']);
			db_qfree($result);

			$querystr = "SELECT COUNT(cat_id) AS ncats FROM cat_links "
					. "WHERE parent=$cid_q";
			$result = db_query($querystr);
			$temp = db_getrow($result);
			$nsc = db_dequote($temp['ncats']);
			db_qfree($result);

			/* See what we have, error out if necessary */
			if($nbm>0 || $nsc>0)
			{
				print <<< _EOF_
<h1>Error</h1>
<p>
 Category $cat_id has children ($nsc categories, $nbm bookmarks) 
 , and thus can't be deleted.
</p>
<p>
 <a href="bookmarks.php?conf=$confenc">Back to bookmarks</a>
</p>

_EOF_;
				/* synhi: ' */
				print_foot();
				exit(1);
			}

			/* Begin this transaction */
			db_query("BEGIN");

			/* Delete an entry */
			$querystr = "DELETE FROM cat_links WHERE cat_id=$cid_q";
			db_query($querystr);

			$querystr = "DELETE FROM categories WHERE cat_id=$cid_q";
			db_query($querystr);

			/* Commit this transaction */
			db_query("COMMIT");

			/* Success */
			if($conf['debug']==1)
			{
				/* If in debug mode, print a message */
				print("<p>Ex-category number $cat_id deleted!</p>\n"
						. "<p><a href=\"bookmarks.php?conf=$confenc\">"
						. "Back to bookmarks</a></p>\n");
				print_foot();
				exit(0);
			}
			else
			{
				/* Else, just bounce */
				header("Location: bookmarks.php?conf=$confenc");
				exit(0);
			}
		}

		/* Lookup this bookmark's info */
		$querystr = <<< _EOF_
SELECT
  c1.name AS myname,
  c2.name AS parent
FROM
  categories c1 FULL OUTER JOIN cat_links cl1 USING (cat_id),
  cat_links cl2 LEFT JOIN categories c2 ON c2.cat_id=cl2.parent
WHERE
  c1.cat_id=$cid_q
 AND
  cl2.parent=cl1.parent
 AND
  cl2.cat_id=cl1.cat_id

_EOF_;

		$result = db_query($querystr);
		$nrows = db_numrows($result);
		if($nrows == 0)
		{
			print("<h1>Error</h1>\n<p>Category ID not found!</p>\n"
					. "<p><a href=\"bookmarks.php?conf=$confenc\">"
					. "Back to Bookmarks</a></p>\n");
			print_foot();
			exit(1);
		}

		/* Build catinfo */
		$catinfo = array();
		$catinfo['parents'] = array();
		$catinfo['cat_id'] = $cat_id;
		while($info = db_getrow($result))
		{
			$catinfo['name'] = db_dequote($info['myname']);
			array_unshift($catinfo['parents'],
					db_dequote($info['parent']));
		}
		db_qfree($result);

		print <<< _EOF_
<h1>CONFIRM DELETE</h1>
<form action="$self" method="post">

_EOF_;

		print_cat_form($catinfo);

		print <<< _EOF_
 <p>
  Are you <em>SURE</em> you want to permamently delete this category?
 </p>
 <p>
  <input type="hidden" name="amode" value="catdele" />
  <input type="hidden" name="conf" value="$confenc" />
  <input type="hidden" name="cat_id" value="$cat_id" />
  <input type="submit" name="commit" value="Commit" />
 </p>
</form>
<form method="get" action="bookmarks.php">
 <p>
  <input type="hidden" name="conf" value="$confenc" />
  <input type="submit" name="dummy" value="Back to Bookmarks" />
 </p>
</form>

_EOF_;

		/* That's it */
		print_foot();
		exit(0);
	}

	/* We should never get here */
	print_head("Bookmark Administration :: Error", $rcsid);
	print <<< _EOF_
<h1>Internal error</h1>
<p>What the hell?</p>
<p><a href="bookmarks.php?conf=$confenc">Back to bookmarks</a></p>

_EOF_;
	exit(1);

	/* That's all, folks */
